﻿Public Class Form1
#Region "Allgemein"
    Private Sub tc_main_SelectedIndexChanged(sender As Object, e As EventArgs) Handles tc_main.SelectedIndexChanged
        If tc_main.SelectedIndex = 3 Then
            tc_main.Color = Color.Orange
            pnl_Statusleiste.BackColor = Color.Orange
            lbl_Version.ForeColor = Color.Black
            lbl_About.ForeColor = Color.Black
        Else
            tc_main.Color = Color.CornflowerBlue
            pnl_Statusleiste.BackColor = Color.CornflowerBlue
            lbl_Version.ForeColor = Color.White
            lbl_About.ForeColor = Color.White
        End If
        If tc_main.SelectedIndex = 2 Then
            cb_DruckenDrucker.Items.Clear()
            For Each Drucker In Drawing.Printing.PrinterSettings.InstalledPrinters
                cb_DruckenDrucker.Items.Add(Drucker)
            Next
            cb_DruckenDrucker.Text = pd_Drucken.PrinterSettings.PrinterName
            pd_Drucken.DocumentName = "StundenPlanor"
            ppc_Drucken.Document = pd_Drucken
            ppc_Drucken.InvalidatePreview()
        End If
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        BackgroundWorker1.RunWorkerAsync()
    End Sub

    Private Sub BackgroundWorker1_DoWork(sender As Object, e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        CheckForIllegalCrossThreadCalls = False
        Dim WC As New Net.WebClient
        WC.Encoding = System.Text.Encoding.UTF8
        Try
            lbl_News.Text = WC.DownloadString("https://felixprogram.lima-city.de/Projekte/StundenPlanor/News")
        Catch ex As Exception
            lbl_News.Text = "News konnten nicht geladen werden"
        End Try
    End Sub

    Public Function MyInputBox(ByVal EingabeText As String) As String
        Dim MIB As New MyInputBox With {.EingabeText = EingabeText}
        If MIB.ShowDialog = DialogResult.OK Then
            Return MIB.Eingabe
        Else
            Return ""
        End If
    End Function


    Private Sub ll_Erstellen_Click(sender As Object, e As EventArgs) Handles ll_Erstellen.Click
        tc_main.SelectedIndex = 1
    End Sub

    Private Sub ll_VBPVocTrainor_Click(sender As Object, e As EventArgs) Handles ll_VBPVocTrainor.Click
        Process.Start("https://www.vb-paradise.de/index.php/Thread/110584-VocTrainor-einfacher-funktionsreicher-Vokabeltrainer/")
    End Sub
#End Region

#Region "Erstellen"
    Private Sub nud_ErstellenLänge_ValueChanged(sender As Object, e As EventArgs) Handles nud_ErstellenLänge.ValueChanged
        If pnl_ErstellenStunden.Controls.Count > nud_ErstellenLänge.Value Then
            Do
                For Each o As Object In pnl_ErstellenStunden.Controls
                    Dim Stunde As uc_Stunde = CType(o, uc_Stunde)
                    If Stunde.Index > nud_ErstellenLänge.Value Then
                        pnl_ErstellenStunden.Controls.Remove(Stunde)
                    End If
                Next
            Loop Until pnl_ErstellenStunden.Controls.Count = nud_ErstellenLänge.Value
            pnl_ErstellenStunden.Height = (pnl_ErstellenStunden.Controls.Count) * 23
        ElseIf pnl_ErstellenStunden.Controls.Count < nud_ErstellenLänge.Value
            Do
                Dim Stunde As New uc_Stunde
                Stunde.Index = pnl_ErstellenStunden.Controls.Count + 1
                Stunde.Location = New Point(0, pnl_ErstellenStunden.Controls.Count * 23)
                pnl_ErstellenStunden.Controls.Add(Stunde)
            Loop Until pnl_ErstellenStunden.Controls.Count = nud_ErstellenLänge.Value
            pnl_ErstellenStunden.Height = (pnl_ErstellenStunden.Controls.Count) * 23
        End If
    End Sub
#End Region

#Region "Drucken"
    Dim Seitenindex As Integer = 0
    Private Sub pd_Drucken_PrintPage(sender As Object, e As Printing.PrintPageEventArgs) Handles pd_Drucken.PrintPage
        With e.Graphics
            .PageUnit = GraphicsUnit.Millimeter
            'Kopfzeile
            If cb_DruckenSW.Checked Then
                .DrawImage(My.Resources.LogoSW, 20, 20, 20, 20)
            Else
                .DrawImage(My.Resources.Logo, 20, 20, 20, 20)
            End If
            .DrawString("StundenPlanor", New Font("Segoe UI Light", 30), Brushes.Black, 40, 20)
            .DrawString("Mit StundenPlanor kannst du deine Schulstunden auf Papier bringen", New Font("Segoe UI Light", 15), Brushes.Black, 41, 32)
            .DrawLine(New Pen(Brushes.Black, 0.5), 40, 39, 191, 39)
            .DrawString("Stand: " & Now.Date.ToShortDateString, New Font("Segoe UI Light", 12), Brushes.Black, 130, 47)
            .DrawString("Seite " & (Seitenindex + 1).ToString, New Font("Segoe UI Light", 12), Brushes.Black, 130, 52)
            .DrawString(tb_ErstellenÜberschrift.Text, New Font("Segoe UI Light", 30), Brushes.Black, 20, 45)
            If Seitenindex = 0 Then
                If Not cb_DruckenNoStats.Checked Then
                    e.HasMorePages = True
                    Seitenindex = 1
                End If
                'Stundenplan
                .DrawString(tb_ErstellenÜberschrift.Text, New Font("Segoe UI Light", 30, FontStyle.Bold), Brushes.Black, 95 - CInt(.MeasureString(tb_ErstellenÜberschrift.Text, New Font("Segoe UI Light", 20)).Width / 2), 75)
                    .DrawString("Zeit", New Font("Segoe UI Light", 20, FontStyle.Bold), Brushes.Black, 34 - CInt(.MeasureString("Zeit", New Font("Segoe UI Light", 20)).Width / 2), 90)
                    .DrawString("Mo", New Font("Segoe UI Light", 20, FontStyle.Bold), Brushes.Black, 62 - CInt(.MeasureString("Mo", New Font("Segoe UI Light", 20)).Width / 2), 90)
                    .DrawString("Di", New Font("Segoe UI Light", 20, FontStyle.Bold), Brushes.Black, 90 - CInt(.MeasureString("Di", New Font("Segoe UI Light", 20)).Width / 2), 90)
                    .DrawString("Mi", New Font("Segoe UI Light", 20, FontStyle.Bold), Brushes.Black, 118 - CInt(.MeasureString("Mi", New Font("Segoe UI Light", 20)).Width / 2), 90)
                    .DrawString("Do", New Font("Segoe UI Light", 20, FontStyle.Bold), Brushes.Black, 146 - CInt(.MeasureString("Do", New Font("Segoe UI Light", 20)).Width / 2), 90)
                    .DrawString("Fr", New Font("Segoe UI Light", 20, FontStyle.Bold), Brushes.Black, 174 - CInt(.MeasureString("Fr", New Font("Segoe UI Light", 20)).Width / 2), 90)

                    .DrawLine(New Pen(Color.Black, 0.25), 20, 100, 190, 100)
                    .DrawLine(New Pen(Color.Black, 0.25), 20, 100, 20, pnl_ErstellenStunden.Controls.Count * 10 + 100)
                    .DrawLine(New Pen(Color.Black, 0.25), 190, 100, 190, pnl_ErstellenStunden.Controls.Count * 10 + 100)
                    .DrawLine(New Pen(Color.Black, 0.25), 20, pnl_ErstellenStunden.Controls.Count * 10 + 100, 190, pnl_ErstellenStunden.Controls.Count * 10 + 100)
                    For i As Integer = 1 To 6
                        .DrawLine(New Pen(Color.Black, 0.25), CSng(((190 - 20) / 6) * i + 20), 100, CSng(((190 - 20) / 6) * i + 20), pnl_ErstellenStunden.Controls.Count * 10 + 100)
                    Next
                    For Each o As Object In pnl_ErstellenStunden.Controls
                        Dim Stunde As uc_Stunde = CType(o, uc_Stunde)
                        .DrawString(Stunde.Zeit, New Font("Segoe UI Light", 20), Brushes.Black, 34 - CInt(.MeasureString(Stunde.Zeit, New Font("Segoe UI Light", 20)).Width / 2), (Stunde.Index - 1) * 10 + 100)
                        .DrawString(Stunde.Mo, New Font("Segoe UI Light", 20), Brushes.Black, 62 - CInt(.MeasureString(Stunde.Mo, New Font("Segoe UI Light", 20)).Width / 2), (Stunde.Index - 1) * 10 + 100)
                        .DrawString(Stunde.Di, New Font("Segoe UI Light", 20), Brushes.Black, 90 - CInt(.MeasureString(Stunde.Di, New Font("Segoe UI Light", 20)).Width / 2), (Stunde.Index - 1) * 10 + 100)
                        .DrawString(Stunde.Mi, New Font("Segoe UI Light", 20), Brushes.Black, 118 - CInt(.MeasureString(Stunde.Mi, New Font("Segoe UI Light", 20)).Width / 2), (Stunde.Index - 1) * 10 + 100)
                        .DrawString(Stunde.Do, New Font("Segoe UI Light", 20), Brushes.Black, 146 - CInt(.MeasureString(Stunde.Do, New Font("Segoe UI Light", 20)).Width / 2), (Stunde.Index - 1) * 10 + 100)
                        .DrawString(Stunde.Fr, New Font("Segoe UI Light", 20), Brushes.Black, 174 - CInt(.MeasureString(Stunde.Fr, New Font("Segoe UI Light", 20)).Width / 2), (Stunde.Index - 1) * 10 + 100)
                        .DrawLine(New Pen(Color.Black, 0.25), 20, (Stunde.Index - 1) * 10 + 100, 190, (Stunde.Index - 1) * 10 + 100)
                    Next
                ElseIf Seitenindex = 1 Then
                    Seitenindex = 0
                'Grafiken
                Dim L As New List(Of String)
                For Each o As Object In pnl_ErstellenStunden.Controls
                    Dim Stunde As uc_Stunde = CType(o, uc_Stunde)
                    If L.Contains(Stunde.Mo) = False AndAlso Stunde.Mo <> "" Then
                        L.Add(Stunde.Mo)
                    End If
                    If L.Contains(Stunde.Di) = False AndAlso Stunde.Di <> "" Then
                        L.Add(Stunde.Di)
                    End If
                    If L.Contains(Stunde.Mi) = False AndAlso Stunde.Mi <> "" Then
                        L.Add(Stunde.Mi)
                    End If
                    If L.Contains(Stunde.Do) = False AndAlso Stunde.Do <> "" Then
                        L.Add(Stunde.Do)
                    End If
                    If L.Contains(Stunde.Fr) = False AndAlso Stunde.Fr <> "" Then
                        L.Add(Stunde.Fr)
                    End If
                Next
                Dim L2 As New List(Of String)
                Dim Höchstes As Integer = 0
                For Each i In L
                    Dim Zähler As Integer = 0
                    For Each o As Object In pnl_ErstellenStunden.Controls
                        Dim Stunde As uc_Stunde = CType(o, uc_Stunde)
                        If Stunde.Mo = i Then
                            Zähler += 1
                        End If
                        If Stunde.Di = i Then
                            Zähler += 1
                        End If
                        If Stunde.Mi = i Then
                            Zähler += 1
                        End If
                        If Stunde.Do = i Then
                            Zähler += 1
                        End If
                        If Stunde.Fr = i Then
                            Zähler += 1
                        End If
                    Next
                    L2.Add(i & "|" & Zähler.ToString)
                    If Zähler > Höchstes Then
                        Höchstes = Zähler
                    End If
                Next
                Dim Höhe As Integer = 70
                For Each i In L2
                    If Not i.Split("|"c)(0).Equals("-") Then
                        If cb_DruckenSW.Checked Then
                            .FillRectangle(Brushes.Gray, 20, Höhe, CSng(170 / Höchstes * CInt(i.Split("|"c)(1))), 10)
                        Else
                            .FillRectangle(Brushes.CornflowerBlue, 20, Höhe, CSng(170 / Höchstes * CInt(i.Split("|"c)(1))), 10)
                        End If
                        .DrawString(i.Split("|"c)(0), New Font("Segoe UI Light", 20), Brushes.White, 22, Höhe - 5 + .MeasureString(i.Split("|"c)(0), New Font("Segoe UI Light", 20)).Height / 2)
                        .DrawString(i.Split("|"c)(1), New Font("Segoe UI Light", 20), Brushes.White, 20 + CInt(170 / Höchstes * CInt(i.Split("|"c)(1))) - .MeasureString(i.Split("|"c)(1), New Font("Segoe UI Light", 20)).Width, Höhe - 5 + .MeasureString(i.Split("|"c)(1), New Font("Segoe UI Light", 20)).Height / 2)
                        Höhe += 11
                    End If
                Next
            End If
        End With
    End Sub

    Private Sub cb_Drucken_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cb_DruckenDrucker.SelectedIndexChanged
        pd_Drucken.PrinterSettings.PrinterName = cb_DruckenDrucker.SelectedItem.ToString
        ppc_Drucken.Invalidate()
    End Sub

    Private Sub pnl_drucken_Paint(sender As Object, e As PaintEventArgs) Handles pnl_drucken.Paint
        e.Graphics.DrawLine(Pens.Black, pnl_drucken.Width - 1, 0, pnl_drucken.Width - 1, pnl_drucken.Height)
    End Sub

    Private Sub nud_DruckenExemplare_ValueChanged(sender As Object, e As EventArgs) Handles nud_DruckenExemplare.ValueChanged
        pd_Drucken.PrinterSettings.Copies = CShort(nud_DruckenExemplare.Value)
    End Sub

    Private Sub Form1_Resize(sender As Object, e As EventArgs) Handles Me.Resize
        ppc_Drucken.AutoZoom = True
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        pd_Drucken.Print()
    End Sub

    Private Sub CheckBox1_CheckedChanged(sender As Object, e As EventArgs) Handles cb_DruckenSW.CheckedChanged
        ppc_Drucken.InvalidatePreview()
    End Sub

    Private Sub CheckBox2_CheckedChanged(sender As Object, e As EventArgs) Handles cb_DruckenNoStats.CheckedChanged
        ppc_Drucken.InvalidatePreview()
    End Sub

#End Region


End Class
