﻿Imports System.Drawing.Drawing2D
Imports System.Drawing

Public Class MyTabControl
    Inherits TabControl

    Public Property [Color] As Color = Color.CornflowerBlue
    Private SF As New StringFormat With {.Alignment = StringAlignment.Center, .LineAlignment = StringAlignment.Center}
    <System.ComponentModel.Browsable(True)>
    Public Sub New()
        SetStyle(ControlStyles.AllPaintingInWmPaint Or ControlStyles.ResizeRedraw Or ControlStyles.UserPaint Or ControlStyles.DoubleBuffer, True)
        DrawMode = TabDrawMode.OwnerDrawFixed
        SizeMode = TabSizeMode.Fixed
        Alignment = TabAlignment.Top
        ItemSize = New Size(100, 30)
        Size = New Size(600, 350)
        Timer1.Interval = 1
    End Sub
    Protected Overrides Sub OnPaintBackground(ByVal pevent As PaintEventArgs)
        MyBase.OnPaintBackground(pevent)
        pevent.Graphics.FillRectangle(New SolidBrush(Color.White), Me.ClientRectangle)
    End Sub
    Protected Overrides Sub OnPaint(ByVal e As PaintEventArgs)
        MyBase.OnPaint(e)
        With e.Graphics
            .DrawLine(New Pen(Color, 5), ActualPosition, 30, ActualPosition + 90, 30)
            For i = 0 To TabCount - 1
                Dim r As New Rectangle(New Point(GetTabRect(i).Location.X - 2, GetTabRect(i).Location.Y + 2), New Size(GetTabRect(i).Width + 3, GetTabRect(i).Height))
                If DesignMode = False AndAlso HoverTab = i AndAlso IsHover = True AndAlso HoverTab <> Me.SelectedIndex Then
                    .DrawString(TabPages(i).Text, New Font("Segoe UI", 9), New SolidBrush(Color), r, SF)
                ElseIf i = Me.SelectedIndex Then
                    .DrawString(TabPages(i).Text, New Font("Segoe UI", 9, FontStyle.Bold), New SolidBrush(Color.Black), r, SF)
                Else
                    .DrawString(TabPages(i).Text, New Font("Segoe UI", 9), New SolidBrush(Color.Black), r, SF)
                End If
            Next
        End With
    End Sub
    Private WithEvents Timer1 As New Timer

    Dim ActualPosition As Integer = 5
    Dim Zähler As Integer = 0
    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If ActualPosition < (GetTabRect(SelectedIndex).Left + 5) Then
            ActualPosition += CInt((GetTabRect(SelectedIndex).Left + 5 - ActualPosition) / 5) + 1
            Me.Invalidate()
        ElseIf ActualPosition > (GetTabRect(SelectedIndex).Left + 5) Then
            ActualPosition -= CInt((ActualPosition - (GetTabRect(SelectedIndex).Left + 5)) / 5) + 1
            Me.Invalidate()
        End If
        If ActualPosition = GetTabRect(SelectedIndex).Left + 5 OrElse Zähler > 200 Then
            Timer1.Stop()
            Zähler = 0
        Else
            Zähler += 1
        End If
    End Sub
    Dim HoverTab As Integer = 0
    Dim IsHover As Boolean = False

    Private Sub VTTabControl_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.MouseLeave
        IsHover = False
        Me.Invalidate()
    End Sub
    Private Sub VTTabControl_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        IsHover = True
        For i = 0 To TabCount - 1
            Dim r As New Rectangle(New Point(GetTabRect(i).Location.X - 2, GetTabRect(i).Location.Y + 2), New Size(GetTabRect(i).Width + 3, GetTabRect(i).Height))
            If r.Contains(Me.PointToClient(Cursor.Position)) Then
                HoverTab = i
                Me.Invalidate()
                Exit For
            End If
        Next
    End Sub

    Private Sub VTTabControl_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SelectedIndexChanged
        Zähler = 0
        Timer1.Start()
    End Sub
End Class
